<?php		

	/**
	 *	Edit ad (Admin)
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */


	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");

	// Only valid, if PHP is not in safe_mode!
	@set_time_limit(180);

	
	// Update the database
	function UpdateDatabase($iAdId=-1, $PicLink="")		{
		
		if($iAdId<=0)	{ return false; }
		
		// Add Advertisment to Database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		
		if($DB==false)	{
			echo LANG_DBCONNECTERRORCUST;
			die();
		}
	
		$sql = BuildSQLString($iAdId,$PicLink);
		$RetVal = $DB->dbupdate($sql);
		if($RetVal)		{
			
			if($GLOBALS['USE_FREE_FIELDS'])		{
				// Try to write the free field data
				$DB->dbupdate(BuildFFSQL($iAdId));
			}
			LogActions("MSED","ID: ".$iAdId." - Titel: ".
				$_POST['f_title'], 0);	
		}
		return $RetVal;
	}
	
	
	function BuildSQLString($iAdID, $PicLink="")		{

		// Build string
		$adeditdate = date("Y.m.d H:i:s", time());

		$RetVal = "UPDATE cf_ads SET ".
			"adtitle='".$_POST['f_title']."',adeditdate='".$adeditdate."',".
			"adtext='".$_POST['f_text']."',adtel='".$_POST['f_tel']."',ademail='".$_POST['f_email']."',".
			"adzip='".$_POST['f_zip']."',adcountry='".$_POST['f_country']."',adcat='".$_POST['f_category']."',".
			"adname='".$_POST['f_name']."',adfax='".$_POST['f_fax']."',adicq='".$_POST['f_icq']."',".
			"adcity='".$_POST['f_city']."',admobile='".$_POST['f_mobile']."',adpiclink='".$PicLink."',".
			"admsn='".$_POST['f_msn']."', adyahoo='".$_POST['f_yahoo']."', adaim='".$_POST['f_aim']."', ".
			"adskype='".$_POST['f_skype']."', adhomepage='".$_POST['f_website']."', adtype=".$_POST['f_adtype']." ".
			"WHERE adid=".$iAdID;		
		return $RetVal;	
	}
	

	function BuildFFSQL($iAdID)	{
		if($iAdID<=0)	{ return FALSE; }
		
		// Build SQL string
		$sql = "UPDATE cf_adfreerows SET ".
			"freecol01='".(isset($_POST['f_field1'])?$_POST['f_field1']:"")."',".
			"freecol02='".(isset($_POST['f_field2'])?$_POST['f_field2']:"")."',".
			"freecol03='".(isset($_POST['f_field3'])?$_POST['f_field3']:"")."',".
			"freecol04='".(isset($_POST['f_field4'])?$_POST['f_field4']:"")."',".
			"freecol05='".(isset($_POST['f_field5'])?$_POST['f_field5']:"")."',".
			"freecol06='".(isset($_POST['f_field6'])?$_POST['f_field6']:"")."',".
			"freecol07='".(isset($_POST['f_field7'])?$_POST['f_field7']:"")."',".
			"freecol08='".(isset($_POST['f_field8'])?$_POST['f_field8']:"")."',".
			"freecol09='".(isset($_POST['f_field9'])?$_POST['f_field9']:"")."',".
			"freecol10='".(isset($_POST['f_field10'])?$_POST['f_field10']:"")."',".
			"freecoldesc='".GetFreeFields(0,true,true)."' ".
			"WHERE adid=".$iAdID;

		return $sql;		
	}
	

	//
	// Init variables
	//
	$PageTitle = GetPageTitle(LANG_TTLEDMYMESS);
	include "inc/header.inc.php";
		
	$AdTest = array( 	"nametest"		=> TRUE,
						"citytest"		=> TRUE,
						"emailtest"		=> TRUE,
						"categorytest"	=> TRUE,
						"adtypetest"	=> TRUE,
						"titletest"		=> TRUE,
						"texttest"		=> TRUE,
						"picturetest"	=> TRUE
	);	
	
	$FreeFieldError = array();
	for($i=1;$i<=10;$i++)	{
		$FreeFieldError[$i] = TRUE;	
	}
	
	
	$bError = FALSE;
	$strMessage = "";
	$iAdID = -1;
	$AgeRestricted = FALSE;
	
	
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR'])!=$_SESSION['admin'])	{
		
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	
	//
	// Determine message id
	//
	if(isset($_GET['adid']))	{
		$iAdID = (integer)$_GET['adid'];
		$_SESSION['s_MsgID'] = $iAdID;
	} elseif(isset($_SESSION['s_MsgID']))	{
		$iAdID = (integer)$_SESSION['s_MsgID'];
	}

	if($iAdID<=0)	{
		ShowErrorMessage(LANG_PAGEPARAMETERERROR);	
		die();
	}

	// Read article data from database and show input form
	$data = GetArticleByID($iAdID);
	if(!is_array($data) || sizeof($data)==0)  { 
		// ****** DO SOME FATAL ACTIVITY
	}
	$arrAdData = $data[0];
	
	
	// Save picture link			
	$LinkName = $arrAdData['adpiclink'];
	
	//
	// Process form
	//
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES")		{
		
		// Convert data
		$_POST['f_text'] = StripSlashes($_POST['f_text']);
		
		// Convert variables
		$_POST['f_title'] = toSafeString($_POST['f_title']);
		$_POST['f_tel'] = toSafeString($_POST['f_tel']);
		$_POST['f_fax'] = toSafeString($_POST['f_fax']);
		$_POST['f_email'] = toSafeString($_POST['f_email']);
		$_POST['f_zip'] = toSafeString($_POST['f_zip']);
		$_POST['f_country'] = toSafeString($_POST['f_country']);
		$_POST['f_category'] = toInt($_POST['f_category']);
		$_POST['f_adtype'] = toInt($_POST['f_adtype']);
		$_POST['f_name'] = toSafeString($_POST['f_name']);
		$_POST['f_icq'] = toSafeString($_POST['f_icq']);
		$_POST['f_yahoo'] = toSafeString($_POST['f_yahoo']);
		$_POST['f_aim'] = toSafeString($_POST['f_aim']);
		$_POST['f_skype'] = toSafeString($_POST['f_skype']);
		$_POST['f_msn'] = toSafeString($_POST['f_msn']);
		$_POST['f_city'] = toSafeString($_POST['f_city']);
		$_POST['f_mobile'] = toSafeString($_POST['f_mobile']);
		
	
		// MandatoryField Check
		if(empty($_POST['f_name'])) 	{ $AdTest['nametest']=false; }
		if(empty($_POST['f_city'])) 	{ $AdTest['citytest']=false; }
		if(empty($_POST['f_email'])) 	{ $AdTest['emailtest']=false; }
		if($_POST['f_category']==(-1)) 	{ $AdTest['categorytest']=false; }
		if($_POST['f_adtype']==(-1))	{ $AdTest['adtypetest']=false; }
		if(empty($_POST['f_title'])) 	{ $AdTest['titletest']=false; }
		if(empty($_POST['f_text'])) 	{ $AdTest['texttest']=false; }
		
		foreach($AdTest as $element)	{
			if(!$element)	{ $bError = true; }
		}
		
		// Check mandatory ff fields
		if($GLOBALS['USE_FREE_FIELDS'])			{

			if(isset($_SESSION['s_FFConfig']) && is_array($_SESSION['s_FFConfig']))		{
				
				$Fields = DecodeFreeFieldDefinitions($_SESSION['s_FFConfig'][0]['freecoldesc'], "", "", FALSE);	
				$i=1;
				if(is_array($Fields))	{
					foreach($Fields as $FieldRow)		{	
						// Walk through all fields
						if($FieldRow['mand']==1 && empty($_POST["f_field$i"]))	{
							$FreeFieldError[$i] = FALSE;
						}
						$i++;
					}
				}
				foreach($FreeFieldError as $element) {
					if($element==FALSE)	{ 
						$bError=TRUE; 
					}
				}
			}
		}
					
		if($bError)	{ 
			$strMessage = LANG_NEWADMANDATORYERROR;
		}
							
		// Check Email-Adress
		if (!$bError && (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$", $_POST['f_email'])))		{
				$AdTest['emailtest'] = FALSE;		
			ShowErrorMessage(LANG_NEWADEMAILERROR);
			$bError=true;
			DisplayForm($_SESSION['s_MsgID'],false,$AdTest,$FreeFieldError);
		}
		
		
		//
		// Picture handling
		//
		if($GLOBALS['LY_ENABLEARTICLEPICS'])	{

			$PictureText = true;
			
			// Check, if picture is too big / upload failed
			if(!$bError && !empty($_FILES['f_UploadPic']['name']) && $_FILES['f_UploadPic']['tmp_name']=="none" && 
				$_FILES['f_UploadPic']['size']=="0")	{
	
				$bError = TRUE;
				$strMessage = ParseIn(LANG_NEWADPICERROR, sprintf("%d",$GLOBALS['LY_MAX_UPLOAD_SIZE']));
				$AdTest['picturetest'] = FALSE;

			} else {
							
				// Do Pictureforming, if picture name is given
				if(($_FILES['f_UploadPic']['tmp_name']<>"none") && 
					($_FILES['f_UploadPic']['name']<>""))		{
				 			
			 		if($GLOBALS['DEBUG'])		{
			 			echo "UPLOADFILE INFORMATION<br>".
			 				"File: ".$_FILES['f_UploadPic']['tmp_name']."<br>".
		 					"Name: ".$_FILES['f_UploadPic']['name']."<br>".
							"Size: ".$_FILES['f_UploadPic']['size']."<br>".
							"Type: ".$_FILES['f_UploadPic']['type']."<br>";
					}
			    	 
					// Create "random" FileName
					$PictureFileName = md5(microtime());
		  		  	$is_Picture = FALSE;
		
				 	// Determine which Filetype we got
			   		switch (strtoupper($_FILES['f_UploadPic']['type'])) {
						case "IMAGE/JPG": case "IMAGE/JPEG": case "IMAGE/PJPEG":	
							$PictureFileName .= ".jpg";
							$is_Picture = true;
							break;
						case "IMAGE/PNG": case "IMAGE/X-PNG":
							$PictureFileName .= ".png";
							$is_Picture = true;
							break;
					}
		
		    	   	if($is_Picture)		{
				    	if($GLOBALS['DEBUG']) {echo "Seems to be a picturefile...<br>";}
				    	
				    	// Move uploaded file    
				    	$UploadFile = $GLOBALS['PD_USERGRAPHICS'].$_FILES['f_UploadPic']['name'];
			         	$LinkName = $PictureFileName;
			      	
						if(move_uploaded_file($_FILES['f_UploadPic']['tmp_name'], $UploadFile))	{
							
							// Process thumbnails
							$tn_image = new Thumbnail($UploadFile,$GLOBALS['LY_THUMBNAIL_WIDTH'],$GLOBALS['LY_THUMBNAIL_HEIGHT']);
						
							// Use advanced picture scaling
							if($GLOBALS['LY_GD_VERSION_2']==TRUE)	{
								$tn_image->SetVersion(true);
							} else { 
								$tn_image->SetVersion(false); 
							}
							
							// Resize and save
							@$tn_image->saveImage($GLOBALS['PD_USERGRAPHICS']."tn_".$PictureFileName);
							$tn_image->SetSize($GLOBALS['LY_MAX_PIC_WIDTH']);
							$tn_image->SetUpsizing($GLOBALS['LY_ALLOW_UPSIZING']);
							@$tn_image->saveImage($GLOBALS['PD_USERGRAPHICS'].$PictureFileName);
							unlink($UploadFile);
							
							// Set save name
							$LinkName = $PictureFileName;
							
							// If picture was exchanged, delete previous files		
							if(!empty($arrAdData['adpiclink']))		{
								$FilenameThumb = $GLOBALS['PD_USERGRAPHICS']."tn_".$arrAdData['adpiclink'];
								$Filename = $GLOBALS['PD_USERGRAPHICS'].$arrAdData['adpiclink'];
								@unlink($FilenameThumb);
								@unlink($Filename);
							}
							
						} else {
							// Error. moving picture to destination directory
							$bError = TRUE;
							$AdTest['picturetest']=false;
							$strMessage = LANG_NEWADPICUPLOADERR;			
						}
					} else {
						// Picture has the wrong format
						$bError = TRUE;
						$strMessage = LANG_NEWADPICFORMATERROR;
						$AdTest['picturetest']=false;
					}
				} elseif(isset($_POST['f_deletepic']) && strtoupper($_POST['f_deletepic'])=="YES")	{
					if(!empty($arrAdData['adpiclink']))	{
						$FilenameThumb = $GLOBALS['PD_USERGRAPHICS']."tn_".$arrAdData['adpiclink'];
						$Filename = $GLOBALS['PD_USERGRAPHICS'].$arrAdData['adpiclink'];
						@unlink($FilenameThumb);
						@unlink($Filename);
						
						$LinkName = "";
					}
				}
							
			}
		}	// End: Picturehandling							
		

		// If everything is okay, add to database	
		if(!$bError)	{
			
			$RetVal=UpdateDatabase($iAdID, $LinkName);
			if(!$RetVal)	{
				$bError = TRUE;
				$strMessage = LANG_NEWADADDERROR;
			} else {

				// Redirect user to user message overview
				$strMessage = LANG_GENERALEDITSUCCESS;
			}
		}
	} else {
		// First display
		
		// Set form fields
		$_POST['f_name'] = $arrAdData['adname'];
		$_POST['f_zip'] = $arrAdData['adzip'];
		$_POST['f_city'] = $arrAdData['adcity'];
		$_POST['f_country'] = $arrAdData['adcountry'];
		$_POST['f_tel'] = $arrAdData['adtel'];
		$_POST['f_fax'] = $arrAdData['adfax'];
		$_POST['f_email'] = $arrAdData['ademail'];
		$_POST['f_title'] = $arrAdData['adtitle'];
		$_POST['f_icq'] = $arrAdData['adicq'];
		$_POST['f_text'] = $arrAdData['adtext'];
		$_POST['f_mobile'] = $arrAdData['admobile'];
		$_POST['f_category'] = $arrAdData['adcat'];
		$_POST['f_adtype'] = $arrAdData['adtype'];
		$_POST['f_website'] = $arrAdData['adhomepage'];
		$_POST['f_msn'] = $arrAdData['admsn'];
		$_POST['f_yahoo'] = $arrAdData['adyahoo'];
		$_POST['f_aim'] = $arrAdData['adaim'];
		$_POST['f_skype'] = $arrAdData['adskype'];
		
		if($GLOBALS['USE_FREE_FIELDS'])	{
			$_SESSION['s_FFConfig'] = GetFreeFields($iAdID, FALSE);
			for($i=1; $i<=10; $i++)		{
				$strField = "freecol".sprintf("%02d",$i);
				$_POST["f_field$i"] = $_SESSION['s_FFConfig'][0][$strField];
			}
		}

	}

	// Prepare Picturelink to display					
	if(!empty($LinkName))	{
		$PictureSrcLink = "<img src=\"".$GLOBALS['PD_USERGRAPHICS'].$LinkName."\">";					
		$PicAttached = TRUE;
	} else {
		$PictureSrcLink = LANG_ERRORNOPICATTACHED;
		$PicAttached = FALSE;
	}

	
	//
	// Display template
	//
	$ImgError = "<img src=\"".$GLOBALS['PD_SCRIPTGRAPHICS']."x.gif\" valign=\"center\">";
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".
		"<a href=\"usermymessages.php\">".LANG_TTLMYMESS."</a>".
		"&nbsp;&gt;&nbsp;".
		LANG_TTLEDMYMESS.
		"&nbsp;&gt;&nbsp;".
		$arrAdData['adtitle'];

	$strCountrySelect = GetCountriesForDropDown($_POST['f_country']);
	$strAdTypeSelect = GetAdTypesForDropDown($_POST['f_adtype'],TRUE);
	$strIpAddress = $arrAdData['adipadress'];
	$strInDate = ParseIn(LANG_INPADMINEDTMSGINIP, $arrAdData['adindate'], $strIpAddress);
	$strOutDate = FormatDate($arrAdData['adoutdate']);

	// Free field handling
	if($GLOBALS['USE_FREE_FIELDS'])		{
		
		if(isset($_SESSION['s_FFConfig']) && is_array($_SESSION['s_FFConfig']))	{ 
			
			// Copy all freefield data into array first
			$ArrayValue = array();
			for($i=1; $i<=10; $i++)	{
				$ArrayValue[$i] = (isset($_POST["f_field$i"])?$_POST["f_field$i"]:"");	
			}

			foreach($_SESSION['s_FFConfig'] as $Column)		{
				$FreeField=DecodeFreeFieldDefinitions($Column['freecoldesc'], $ArrayValue, $FreeFieldError,true);
			}
		}
	}	
	
	// Read categories
	if($GLOBALS['OP_SIMPLE_CATS'])	{
		$OptionList = GetCategoriesForSelect($_POST['f_category'], $AgeRestricted, FALSE);
	} else {
		
		// Complex cats
		require_once("inc/adv_categories.inc.php");
		
		$oCatManager = new CatTreeManager();
		$oRoot = $oCatManager->GetTreeRoot();
		$oTreeWork = new CategoryTreeWorks($oRoot);
		$OptionList = $oTreeWork->GetCategoryForSelect($_POST['f_category'],TRUE);
	}
	
	
			
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_editmessagedetails.tpl.php";
	include "inc/footer.inc.php";
	

	
?>