<?php		

	/**
	 *	Login user
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */

	
	// Include necessary modules
	include "inc/includer.inc.php";

	
	// Start display
	$PageTitle = GetPageTitle(LANG_TTLRELEASEUSER);
	include "inc/header.inc.php";
	
	
	// Init
	$bError = FALSE; $strMessage = "";
	$strRedirectPage = "";
	$strBreadCrumb = "";
	
	$iUserId = -1;
	$strSecCode = "";

	
	if(isset($_GET['userid']) || isset($_GET['seccode']))		{
		
		// Get parameters
		if(isset($_GET['userid']))	{
			$iUserId = (integer)$_GET['userid'];
		}
	
		if(isset($_GET['seccode']))	{
			$strSecCode = toSafeString($_GET['seccode']);
		}
		
	} elseif(isset($_POST['f_send']) && strtoupper($_POST['f_send'])=="YES")	{
		
		$iUserId = (integer)$_POST['f_userid'];
		$strSecCode = toSafeString($_POST['f_seccode']);
		
	} else {
		
		$iUserId = "";
		$strSecCode = "";
		
	}
	
	
	// Test input
	if($iUserId<=0 || empty($strSecCode))	{
		// Missing parameters
		$bError = TRUE;
		$strMessage = LANG_RELUSERPARAMETERERR;
		
		
	} else {
		
		$iRetVal = ReleaseUser($iUserId,$strSecCode);
		
		if($iRetVal != SUCCESS)	{

			$bError = TRUE;
			switch($iRetVal)	{
				case ERR_RELEASE_UNKNOWN_USER:
					$strMessage = LANG_RELUSERUNKNOWNUSER;
					break;
				case ERR_RELEASE_CODE_WRONG:
					$strMessage = LANG_RELUSERWRONGCODE;
					break;
				case ERR_RELEASE_ALREADY_RELEASED:
					$strMessage = LANG_RELUSERALREADYRELEASED;
					break;
				default:
					$strMessage = LANG_RELUSERCOMMONERR;
					break;
			}
		} else {
			$strMessage = LANG_RELUSERSUCCESS;	
			
			include "templates/".$GLOBALS['ACTIVELANGUAGE']."/success.tpl.php";
			include "inc/footer.inc.php";
			die();
		}
	}
	
	//
	// Display template
	//
	$strBreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".LANG_TTLRELEASEUSER;
		
	$_POST['f_seccode'] = $strSecCode;
	$_POST['f_userid'] = $iUserId;	
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/releaseuser.tpl.php";
	include "inc/footer.inc.php";
	
?>