<?

	//	cts ClassAd Version 3.5
	// 	Base class								
	//
	//	Notes: -
	//
	// (c) 2002-2005 cts projects&software, www.how2pc.de/classad


if (!defined('__BASECLASS__')) {
    define('__BASECLASS__', 1);	
	

	class FileWriter
	{
		// Class used to write to textfiles like logfile etc.
			
		// Attributs
		var $FHandle="";
				
		// Open File for Out/Input
		function fwInit($filename="")	{
			if(empty($filename))	{return false;}
						
			$file = fopen($filename,"a+");
			if(!empty($file))	
			{
				if($GLOBALS['DEBUG'])	{ echo "fwinit: ".$lang9005."<br>\n";	}	
				return false;
			}
			$this->FHandle = $file;
			return true;
		}
		
		
		function fwWriteText($text)		{
			if(empty($text))	{
				if($GLOBALS['DEBUG'])	{echo "fwWriteText: ".$lang9006."<br>\n";	}
				return false;	
			}
			if(empty($this->FHandle))
			{
				global $lang9007;
				if($GLOBALS['DEBUG'])	{echo "fwWriteText: ".$lang9007."<br>\n";}
				return false;
			}
			fputs($this->FHandle,$text);
			return true;
		}
		
		// Special fwWriteText to use for logfile writing
		function fwLogText($logtext,$ip)		{
			$text = localTimeFormat(time())." - ".$logtext." - IP: ".$ip."\r\n";
			return fwWriteText($text);
		}
	
		// Closes a file(-handle)
		function fwClose()		{
			if(empty($this->FHandle))	{return true;}
			return flose($this->FHandle);
		}
	
	}
	
	class Debugger	
	{
		// class used to debug php-scripts
		// essentially based on Hanser phpdebug
		
		var $LogFileName = "";				//////$LOGFILE;
		var $ErrorMessage = "";
		var $ErrorLine = "";
		var $strGlobals = "";
		var $strGet = "";
		var $strPost = "";
		var $strCookie = "";
		var $strError = "";
		var $strLogFile = "";
				
		// Methods
		function SetErrorMessage($ErrorMessage="")		{
			$this->ErrorMessage = $ErrorMessage;
		}
		
		function SetErrorLine($ErrorLine="")	{
			$this->ErrorLine = $ErrorLine;
		}
		
		function SetLogFile($LogFile="")	{
			$this->strLogFile = $LogFile;	
		}
			
		function BuildVarTable($dbg_globals=true,$dbg_get=true,$dbg_post=true,$dbg_cookie=true,$dbg_error=true)
		{
			
			// Log global variables
			if($dbg_globals==true)	{
				$dbgglob = "<br><b>Globale Variablen:</b><code><br>";
				if (is_array($GLOBALS)) {
					while (list($key, $val) = each($GLOBALS)) {
   			   			if ($key!="dbgglob" & $key!="key" & $key!="val" & $key!="__dbg_trace") {
   	   		 				$dbgglob .= "<nobr>".$key." => <font color=green>".$val."</font></nobr><br>";
     					}
  					}
					} else {
					$dbgglob = "<font color=green>Keine ...</font><br>";
				}
				$dbgglob .= "</code>";
			}

			// Post Messages log
			if($dbg_post==true)	{
				$dbgpost = "<br><b>Variablen per POST:</b><code><br>";
				if (is_array($_POST)) {
					while (list($key, $val) = each($_POST)) {
      					$dbgpost .= $key." => <font color=green>".$val."</font><br>";
   					} 
				} else {
   					$dbgpost .= "<font color=green>Keine ...</font><br>";
				}
				$dbgpost .= "</code>";
			}

			// Get Messages log
			if($dbg_get==true)	{
				$dbgget = "<br><b>Variablen per GET:</b><code><br>";
					if (count($_GET)>0) {
   						while (list($key, $val) = each($_GET)) {
      					$dbgget .= $key." => <font color=green>".$val."</font><br>";
   					} 
				} else {
   					$dbgget .= "<font color=green>Keine ...</font><br>";
				}
				$dbgget .= "</code>";
			}

			// Cookies log
			if($dbg_cookie==true)	{
				$dbgcook = "<br><b>Cookies:</b><code><br>";
				if (is_array($_COOKIE)) {
   					while (list($key, $val) = each($_COOKIE)) {
      					$dbgcook .= $key." => <font color=green>".$val."</font><br>";
   					}
				} else {
   					$dbgcook .= "<font color=green>Keine ...</font><br>";
				}
				$dbgcook .= "</code>";
			}

			// Error log
			if($dbg_error==true)	{
				$dbgerr = "<br><b>Fehlermeldungen:</b><br>";
				if (empty($php_errormsg)) {
   					$dbgerr .= "<font color=green><code>Keine ...</code></font><br>";
				} else {
   					$dbgerr .= "<font color=red><code>".$php_errormsg."</code></font><br>";
				}
			}
			
			// save to object attributes	
			$this->strGlobals = dbg_globals;
			$this->strGet = dbg_get;
			$this->strPost = dbg_post;
			$this->strCookie = dbg_cookie;
			$this->strError = dbg_error;
		}
		
		
		// Main method - call this to write debug output
		function debug_me($LogToFile=true)		{
			
			// Get variables' content
			$this->BuildVarTable();
			$strDebugText = $this->strGlobals."<p>".$this->strGet."<p>".$this->strPost."<p>".$this->strCookie."<p>".$this->strError;
			
			// Log to screen or log to file
			if(LogToFile==true)		{
				// Write to file
				$WriteFile = new FileWriter;
				$WriteFile->fwWriteText($strDebugText);
				$WriteFile->fwClose();
				
			}
			else
			{
				// Write to screen!	
				// Attention! This function only works properly with Javascript turned on!
				$JS="<script language=\"JavaScript\">
				debwin = window.open(\"debug.htm\",\"PHPDebugger\",\"alwaysRaised=yes,directories=no,hotkeys=no,location=no,resizable=no,screenX=0,screenY=0,status=no,titlebar=no,toolbar=no,width=300,height=500\");
				debwin.dbgpost = \"<? echo $dbgpost; ?>\";
				debwin.dbgget = \"<? echo $dbgget; ?>\";
				debwin.dbgglob = \"<? echo $dbgglob; ?>\";
				debwin.dbgcook = \"<? echo $dbgcook; ?>\";
				debwin.dbgerr = \"<? echo $dbgerr; ?>\";
				debwin.control.document.write(\"<HTML><HEAD></HEAD><BODY bgcolor=#fafad2>\n\");
				debwin.control.document.write(\"<SPAN onclick=\'parent.debug.document.write(parent.dbgpost)\'><U>[POST] </U></SPAN>\n\");
				debwin.control.document.write(\"<SPAN onclick=\'parent.debug.document.write(parent.dbgget)\'><U> [GET] </U></SPAN>\n\");
				debwin.control.document.write(\"<SPAN onclick=\'parent.debug.document.write(parent.dbgglob)\'><U> [GLOB] </U></SPAN>\n\");
				debwin.control.document.write(\"<SPAN onclick=\'parent.debug.document.write(parent.dbgcook)\'><U> [COOK] </U></SPAN>\n\");
				debwin.control.document.write(\"<SPAN onclick=\'parent.debug.document.write(parent.dbgerr)\'><U> [ERR] </U></SPAN>\n\");
				debwin.control.document.write(\"</BODY></HTML>\n\");
				debwin.debug.document.write(\"<br><b><font size=-2>[Zeile] (Typ) Zustand/Inhalt {Name/Bemerkung}</font></b><p>\");
				</script>";
				
				echo $JS;
				
				// *** To be continued...
												
			}					
		}				
	}
		
		
	// Class:				ImageConvert
	// based on:			Thumbnail-Class by Hidayet Dogan
	class Thumbnail {
			
	    var $errmsg	  	 	= "";
	    var $error	   	 	= false;
	    var $format	    	= "";
	    var $file	    	= "";
	    var $version2		= false;
	    var $allowupsizing	= true;
	    var $max_width  	= 0;
	    var $max_height 	= 0;
	    var $percent    	= 0;
	
	    function Thumbnail($file, $max_width = 0, $max_height = 0, $percent = 0,$version = false,$upsizing=true) {
		if (!file_exists($file)) {
		    $this->errmsg = "File doesn't exists";
		    $this->error  = true;
		}
		else if (!is_readable($file)) {
		    $this->errmsg = "File is not readable";
		    $this->error  = true;
		}
	   
	   	$this->version2 = $version;
		$this->allowupsizing = $upsizing;
	   
		if (strstr(strtolower($file), ".jpg") ||
			 strstr(strtolower($file), ".jpeg") ||
			 strstr(strtolower($file), ".jpe"))		{
		    $this->format = "JPEG";
		} else if (strstr(strtolower($file), ".png"))	{
		    $this->format = "PNG";
		} else if (strstr(strtolower($file), ".gif"))  {
		    $this->errmsg = "We are sorry! But there is no longer support for GIF-Files in PHP4";
		   	$this->error = true; 
		} else {
		    $this->errmsg = "We are sorry! Unknown file format";
		    $this->error  = true;
		}
	
		if ($max_width == 0 && $max_height == 0 && $percent == 0)
		    $percent = 100;
	
		$this->max_width  = $max_width;
		$this->max_height = $max_height;
		$this->percent	  = $percent;
		$this->file	  = $file;
	    }
	
		function SetVersion($version=false)	{
			$this->version2 = $version;	
		}
		
		function SetUpsizing($upsizing=true)	{
			$this->allowupsizing = $upsizing;
		}
	
		function SetSize($MaxWidth=600, $MaxHeight=600)		{
			$this->max_width  = $MaxWidth;
			$this->max_height = $MaxHeight;
		}
	
	    function calc_width($width, $height) {
			$new_width  = $this->max_width;
			$new_wp     = (100 * $new_width) / $width;
			$new_height = ($height * $new_wp) / 100;
			return array($new_width, $new_height);
	    }
	
	    function calc_height($width, $height) {
			$new_height = $this->max_height;
			$new_hp     = (100 * $new_height) / $height;
			$new_width  = ($width * $new_hp) / 100;
			return array($new_width, $new_height);
	    }
	
	    function calc_percent($width, $height) {
			$new_width  = ($width * $this->percent) / 100;
			$new_height = ($height * $this->percent) / 100;
			return array($new_width, $new_height);
	    }
	
	    function return_value($array) {
			$array[0] = intval($array[0]);
			$array[1] = intval($array[1]);
		return $array;
	    }
	
	    function calc_image_size($width, $height) {
			$new_size = array($width, $height);
		
			if(($this->allowupsizing==false) && ($width<=($this->max_width)))	{
				// Check, if preferred size is bigger than acutal size
			    return $this->return_value($new_size);
			}
		
			if ($this->max_width > 0) {
			    $new_size = $this->calc_width($width, $height);
		
			    if ($this->max_height > 0) {
				if ($new_size[1] > $this->max_height)
				    $new_size = $this->calc_height($new_size[0], $new_size[1]);
			    }
			    return $this->return_value($new_size);
			}
		
			if ($this->max_height > 0) {
			    $new_size = $this->calc_height($width, $height);
			    return $this->return_value($new_size);
			}
		
			if ($this->percent > 0) {
			    $new_size = $this->calc_percent($width, $height);
			    return $this->return_value($new_size);
			}
			return 0;
	    }
	
	    function show_error_image() {
			header("Content-type: image/png");
			$err_img   = ImageCreate(220, 25);
			$bg_color  = ImageColorAllocate($err_img, 0, 0, 0);
			$fg_color1 = ImageColorAllocate($err_img, 255, 255, 255);
			$fg_color2 = ImageColorAllocate($err_img, 255, 0, 0);
			ImageString($err_img, 3, 6, 6, "ERROR:", $fg_color2);
			ImageString($err_img, 3, 55, 6, $this->errmsg, $fg_color1);
			ImagePng($err_img);
			ImageDestroy($err_img);
	    }
	
		function show_error_message()		{
			echo "An error occured: ".$this->errmsg;	
		}
	
		function saveImage($FileName="")	{
			if(empty($FileName) || ($this->error))	{
				$this->error=true;
				$this->show_error_message();
				return false;	
			}
			$size      = GetImageSize($this->file);
			$new_size  = $this->calc_image_size($size[0], $size[1]);
			if($this->version2==true) {$new_image = ImageCreateTrueColor($new_size[0], $new_size[1]);}
			else {$new_image = ImageCreate($new_size[0], $new_size[1]);}
	
			switch ($this->format) {
			    case "GIF":
					$old_image = ImageCreateFromGif($this->file);
					break;
				case "JPEG":
					$old_image = ImageCreateFromJpeg($this->file);
					break;
			    case "PNG":
					$old_image = ImageCreateFromPng($this->file);
					break;
			}
	
			ImageCopyResized($new_image, $old_image, 0, 0, 0, 0, $new_size[0], $new_size[1], $size[0], $size[1]);
	
			switch ($this->format) {
		   	 case "GIF":
					ImageGif($new_image,$FileName);
					break;
				case "JPEG":
					ImageJpeg($new_image,$FileName,70);
					break;
		    	case "PNG":
					ImagePng($new_image,$FileName);
					break;
			}
	
			ImageDestroy($new_image);
			ImageDestroy($old_image);
			return;
		}
	
	
	    function show() {
			if ($this->error) {
		   		$this->show_error_message();
		   		return;
			}
	
			$size      = GetImageSize($this->file);
			$new_size  = $this->calc_image_size($size[0], $size[1]);
			$new_image = ImageCreate($new_size[0], $new_size[1]);
	
			switch ($this->format) {
			    case "GIF":
					$old_image = ImageCreateFromGif($this->file);
					break;
			 	case "JPEG":
					$old_image = ImageCreateFromJpeg($this->file);
					break;
			    case "PNG":
					$old_image = ImageCreateFromPng($this->file);
					break;
			}
	
			ImageCopyResized($new_image, $old_image, 0, 0, 0, 0, $new_size[0], $new_size[1], $size[0], $size[1]);
	
			switch ($this->format) {
		   	 case "GIF":
				header("Content-type: image/gif");
					ImageGif($new_image);
					break;
				case "JPEG":
					header("Content-type: image/jpeg");
					ImageJpeg($new_image);
					break;
		    	case "PNG":
					header("Content-type: image/png");
					ImagePng($new_image);
				break;
			}
	
			ImageDestroy($new_image);
			ImageDestroy($old_image);
			return;
	   	}
	}

	class ICQClass		{
	
		var $ToICQNumber;
		var $FromName;
		var $FromEmail;
		var $BodyText;
		
		function ICQClass($ToICQNumber,$FromName,$FromEmail,$BodyText)	{
			// Constructor
			$this->ToICQNumber = $ToICQNumber;
			$this->FromName = $FromName;
			$this->FromEmail = $FromEmail;
			$this->BodyText = $BodyText;
		}
		
		function ICQError($strMessageText="")	{
			echo "Error in ICQ-Class: ".$strMessageText;			
		}
		
		function SendICQMessage()	{
			
			// Test parameters
			if(empty($this->ToICQNumber) || empty($this->FromEmail) || empty($this->BodyText))		{
				$this->ICQError("Parameters missing or empty!");		
				return false;
			}
			
			// Encode values
			$EncodedString = empty($this->ToICQNumber) ? "" : "to=".$this->ToICQNumber;
			$EncodedString.= empty($this->FromName) ? "" : "&from=".$this->FromName;
			$EncodedString.= empty($this->FromEmail) ? "" : "&fromemail=".$this->FromEmail;
			$EncodedString.= empty($this->BodyText) ? "" : "&body=".$this->BodyText;
	
			// Open Network connection
			$NC = new NetworkConnect("wwp.mirabilis.com",80,"/scripts/WWPMsg.dll","",$EncodedString);
			
			if($NC->NetworkOpen())	{
				// Yes, we are open!
				return $NC->NetworkPostData();	
			} else { return false; }
			$NC->NetworkClose();
			
		}
		
	}
	
	class NetworkConnect			{
		
		// Connects to a network server via TCP/IP
		// $host 			serveraddress to connect
		// $port			port to connect (Standard: 80 for HTTP)
		// $path			path to connect to (i.E. /scripts/index.php)
		// $referer			referer
		// $databody		data to send			 	
		
		// Properties		
		var $host="";				
		var $port=80;
		var $path="";
		var $referer="";
		var $databody="";	
		
		var $TimeOut = 5;
		var $Conn="";
	
		
		// Methods
		function NetworkConnect($host="",$port=80,$path="",$referer="",$databody="")	{
			$this->host = $host;
			$this->port = $port;
			$this->path = $path;
			$this->referer = $referer;
			$this->databody = $databody;	
		}

		function NetworkError($errorNo="",$errorMsg="")		{
			if($GLOBALS['DEBUG'])	{
				echo "<br>Network Error occured!<br>";
				echo "Err-No.: ".$errorNo." (Msg: ".$errorMsg.")";
			}
		}
				
		function NetworkOpen()	{
			$Conn = @fsockopen($this->host,$this->port,$errno,$errstr,$this->TimeOut);
		
			if(!$Conn)	{
				$this->NetworkError($errno,$errstr); 
				return false;	
			}
			$this->Conn = $Conn;
			return true;
		}
		
		function NetworkPostData()		{
			if(!$this->Conn)	{ return false; }	
			
			$RetVal = "";
			
			$ReqHeader = "POST ".$this->path." HTTP/1.1\n".
				"Host: ".$this->host." \n";
			if(isset($this->referer))	{ $ReqHeader.= "Referer: ".$this->referer."\n"; }
						
			$ReqHeader.= "Content-type: application/x-www-form-urlencoded\n".
				"Content-length: ".strlen($this->databody)."\n".
				"Connection: close\n\n".
				$this->databody."\n";
			
			// Send header & post data 
			fputs($this->Conn,$ReqHeader);
	
			// Read data
			while(!feof($this->Conn)) {
				$RetVal .= fgets($this->Conn, 128);
			}
			return $RetVal;
		}
	
		function NetworkClose()			{
			if(!$this->Conn)		{ return false; }
			fclose($this->Conn);
		}
	}

}
	  
?>